diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
index 7ff5c8ea1..b1a7fd616 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
@@ -13,8 +14,6 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.world.World;
 
-import java.util.List;
-
 public class MenuCrafting extends MenuAbstract
 {
 	public ContainerCrafting craftSlots;
@@ -101,7 +100,7 @@ public class MenuCrafting extends MenuAbstract
      */
     
     @Override
-    public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+    public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
     	if(slot.index == 0) {
     		// Craft Result
     		return getSlots(0, 1, false);
@@ -129,7 +128,7 @@ public class MenuCrafting extends MenuAbstract
     }
     
     @Override
-    public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+    public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
     	if(slot.index >= 10 && slot.index <= 45) {
     		// Full ContainerInventory
     		if(target == 1) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
index bdcd6609a..10f7129ae 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
-import java.util.List;
-
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
@@ -39,7 +38,7 @@ public class MenuFlag extends MenuAbstract {
 	 *  30 -  38 Hotbar
 	 */
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 2) {
 			// Dye Slots
 			return getSlots(0, 3, false);
@@ -61,7 +60,7 @@ public class MenuFlag extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 2) {
 			// Dye Slots
 			return getSlots(3, 36, false); // Into ContainerInventory
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
index c31ffea49..f6890db3a 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
-import java.util.List;
-
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.crafting.ContainerListener;
@@ -92,15 +91,15 @@ public class MenuFurnace extends MenuAbstract {
 	}
 
 	/**
-	 *  0 Input
-	 *  1 Fuel
-	 *  2 Output
-	 *  3 - 29 Main ContainerInventory (27x)
-	 * 30 - 38 Hotbar (9x)
-	 */
+     * 0 Input
+     * 1 Fuel
+     * 2 Output
+     * 3 - 29 Main ContainerInventory (27x)
+     * 30 - 38 Hotbar (9x)
+     */
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 3) return getSlots(slot.index, 1, false);
 
 		if(action == InventoryAction.MOVE_ALL) {
@@ -121,7 +120,7 @@ public class MenuFurnace extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 3 && slot.index <= 39) {
 			// Full ContainerInventory
 			if(action != InventoryAction.MOVE_ALL) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
index 4f22ccf54..09a337965 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
@@ -1,12 +1,11 @@
 package net.minecraft.core.player.inventory.menu;
 
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-import java.util.List;
-
 public class MenuGuidebook extends MenuAbstract
 {
 
@@ -22,12 +21,12 @@ public class MenuGuidebook extends MenuAbstract
 	}
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		return null;
 	}
 	
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		return null;
 	}
 	
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
index a69475996..c85448158 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.player.inventory.menu;
 
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.ContainerCrafting;
@@ -14,8 +14,6 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotArmor;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 
-import java.util.List;
-
 public class MenuInventory extends MenuAbstract {
 
 	public ContainerCrafting craftSlots;
@@ -93,7 +91,7 @@ public class MenuInventory extends MenuAbstract {
 	 */
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index == 0) {
 			// Craft Result
 			return getSlots(0, 1, false);
@@ -125,7 +123,7 @@ public class MenuInventory extends MenuAbstract {
 	}
 	
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 9 && slot.index <= 44) {
 			// Full ContainerInventory
 			if(target == 1) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
index ecb705d86..5f35af980 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
-import java.util.List;
-
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.entity.player.Player;
@@ -46,7 +45,7 @@ public class MenuTrap extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= dispenserSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(dispenserSlotsStart, 9, false);
 		}
@@ -68,7 +67,7 @@ public class MenuTrap extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= dispenserSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(inventorySlotsStart, 36, false);
 		}else {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
index 89fd3d854..cc224e04a 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
-import java.util.List;
-
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityTrommel;
 
@@ -86,7 +85,7 @@ public class MenuTrommel extends MenuAbstract {
 	 */
 
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 3) {
 			return getSlots(0, 4, false);
 		}
@@ -113,7 +112,7 @@ public class MenuTrommel extends MenuAbstract {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 4) {
 			// Item and Fuel Slots
 			return getSlots(5, 36, false); // Into ContainerInventory
diff --git a/game/core/src/main/java/net/minecraft/core/sound/SoundTypes.java b/game/core/src/main/java/net/minecraft/core/sound/SoundTypes.java
index 86511985b..48af21e05 100644
--- a/game/core/src/main/java/net/minecraft/core/sound/SoundTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/sound/SoundTypes.java
@@ -6,6 +6,10 @@ import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonParser;
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.net.packet.PacketSyncIDs;
 import org.slf4j.Logger;
 
@@ -16,8 +20,8 @@ import java.util.Map.Entry;
 
 public class SoundTypes {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	private static final Map<Integer, String> idToSoundNameMap = new HashMap<>();
-	private static final Map<String, Integer> soundNameToIdMap = new HashMap<>();
+	private static final Int2ObjectMap<String> idToSoundNameMap = new Int2ObjectOpenHashMap<>();
+	private static final Object2IntMap<String> soundNameToIdMap = new Object2IntOpenHashMap<>();
 	private static final String format = "/assets/%s/sounds/sounds.json";
 	private static int idCount = 0;
 	
@@ -71,11 +75,7 @@ public class SoundTypes {
 	 * Returns -1 if the given soundPath is not registered! 
 	 */
 	public static int getSoundId(final String soundPath) {
-		final Integer id = soundNameToIdMap.get(soundPath);
-		if(id == null) {
-			return -1;
-		}
-		return id;
+		return soundNameToIdMap.getOrDefault(soundPath, -1);
 	}
 	/**
 	 * Returns null if the given id does not exist!
@@ -85,12 +85,12 @@ public class SoundTypes {
 		return idToSoundNameMap.get(id);
 	}
 	
-	public static void setSoundIds(final Map<Integer, String> soundIds) {
+	public static void setSoundIds(final Int2ObjectMap<String> soundIds) {
 		idToSoundNameMap.clear();
 		soundNameToIdMap.clear();
 		
-		for(final Entry<Integer, String> entry : soundIds.entrySet()) {
-			final int id = entry.getKey();
+		for(final Int2ObjectMap.Entry<String> entry : soundIds.int2ObjectEntrySet()) {
+			final int id = entry.getIntKey();
 			final String name = entry.getValue();
 			
 			idToSoundNameMap.put(id, name);
@@ -98,7 +98,7 @@ public class SoundTypes {
 		}
 	}
 	
-	public static Map<Integer, String> getSoundIds() {
+	public static Int2ObjectMap<String> getSoundIds() {
 		// TODO Make soundNameToIdMap immutable
 		return idToSoundNameMap;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java b/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
index 9654978cd..6f653673f 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/BoundingVolume.java
@@ -1,5 +1,10 @@
 package net.minecraft.core.util.phys;
 
+import it.unimi.dsi.fastutil.floats.FloatArrayList;
+import it.unimi.dsi.fastutil.floats.FloatList;
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
+
 import java.util.ArrayList;
 import java.util.EnumSet;
 import java.util.List;
@@ -179,7 +184,7 @@ public class BoundingVolume
 
     public void bake()
     {
-        List<Integer> lineCoords = new ArrayList<>();
+        IntList lineCoords = new IntArrayList();
         float scale = 1f / SIZE;
 
         for (int y = 0; y < SIZE; y++)
@@ -205,12 +210,12 @@ public class BoundingVolume
 
         System.out.println("Before line simplification: " + lineCoords.size() / 6 + " lines");
 
-        List<Integer> mergedLineCoords = mergeLines(lineCoords);
+        IntList mergedLineCoords = mergeLines(lineCoords);
 
         System.out.println("After line simplification: " + mergedLineCoords.size() / 6 + " lines");
 
-        List<Float> floatLineCoords = new ArrayList<>();
-        for (Integer i : mergedLineCoords)
+        FloatList floatLineCoords = new FloatArrayList();
+        for (int i : mergedLineCoords)
         {
             floatLineCoords.add(i * scale);
         }
@@ -218,27 +223,27 @@ public class BoundingVolume
         bakedLineCoords = floatLineCoords.toArray(new Float[0]);
     }
 
-    private List<Integer> mergeLines(List<Integer> lineCoords)
+    private IntList mergeLines(IntList lineCoords)
     {
-        List<Integer> mergedLineCoords = new ArrayList<>();
+        IntList mergedLineCoords = new IntArrayList();
 
         for (int i = 0; i < lineCoords.size(); i += 6)
         {
             boolean lineHandled = false;
             for (int j = 0; j < mergedLineCoords.size(); j += 6)
             {
-                int xMinA = mergedLineCoords.get(j + 0);
-                int yMinA = mergedLineCoords.get(j + 1);
-                int zMinA = mergedLineCoords.get(j + 2);
-                int xMaxA = mergedLineCoords.get(j + 3);
-                int yMaxA = mergedLineCoords.get(j + 4);
-                int zMaxA = mergedLineCoords.get(j + 5);
-                int xMinB = lineCoords.get(i + 0);
-                int yMinB = lineCoords.get(i + 1);
-                int zMinB = lineCoords.get(i + 2);
-                int xMaxB = lineCoords.get(i + 3);
-                int yMaxB = lineCoords.get(i + 4);
-                int zMaxB = lineCoords.get(i + 5);
+                int xMinA = mergedLineCoords.getInt(j + 0);
+                int yMinA = mergedLineCoords.getInt(j + 1);
+                int zMinA = mergedLineCoords.getInt(j + 2);
+                int xMaxA = mergedLineCoords.getInt(j + 3);
+                int yMaxA = mergedLineCoords.getInt(j + 4);
+                int zMaxA = mergedLineCoords.getInt(j + 5);
+                int xMinB = lineCoords.getInt(i + 0);
+                int yMinB = lineCoords.getInt(i + 1);
+                int zMinB = lineCoords.getInt(i + 2);
+                int xMaxB = lineCoords.getInt(i + 3);
+                int yMaxB = lineCoords.getInt(i + 4);
+                int zMaxB = lineCoords.getInt(i + 5);
 
                 if (xMinA == xMinB && yMinA == yMinB && zMinA == zMinB && xMaxA == xMaxB && yMaxA == yMaxB && zMaxA == zMaxB)
                 {
@@ -288,12 +293,12 @@ public class BoundingVolume
 
             if (!lineHandled)
             {
-                mergedLineCoords.add(lineCoords.get(i + 0));
-                mergedLineCoords.add(lineCoords.get(i + 1));
-                mergedLineCoords.add(lineCoords.get(i + 2));
-                mergedLineCoords.add(lineCoords.get(i + 3));
-                mergedLineCoords.add(lineCoords.get(i + 4));
-                mergedLineCoords.add(lineCoords.get(i + 5));
+                mergedLineCoords.add(lineCoords.getInt(i + 0));
+                mergedLineCoords.add(lineCoords.getInt(i + 1));
+                mergedLineCoords.add(lineCoords.getInt(i + 2));
+                mergedLineCoords.add(lineCoords.getInt(i + 3));
+                mergedLineCoords.add(lineCoords.getInt(i + 4));
+                mergedLineCoords.add(lineCoords.getInt(i + 5));
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index b33eab778..85db03fd9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -1,5 +1,8 @@
 package net.minecraft.core.world;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMaps;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.block.Blocks;
@@ -75,15 +78,15 @@ public class Dimension
 		return "Dimension: [ ID: " + id + " Name: " + getTranslatedName() + " ]";
 	}
 
-	private static final Map<Integer, Dimension> dimensionList = new HashMap<>();
+	private static final Int2ObjectMap<Dimension> dimensionList = new Int2ObjectArrayMap<>();
+	private static final Int2ObjectMap<Dimension> dimensionListUnmodifiable = Int2ObjectMaps.unmodifiable(dimensionList);
 
 	public static final Dimension OVERWORLD = new Dimension("overworld", null, 1.0f, null, WorldTypes.OVERWORLD_DEFAULT);
 	public static final Dimension NETHER = new Dimension("nether", OVERWORLD, 0.125f, Blocks.PORTAL_NETHER, WorldTypes.NETHER_DEFAULT);
 	public static final Dimension DRIFT = new Dimension("drift", OVERWORLD, 8.0f, Blocks.PORTAL_DRIFT, WorldTypes.DRIFT_DEFAULT);
 
-	public static Map<Integer, Dimension> getDimensionList()
-	{
-		return Collections.unmodifiableMap(dimensionList);
+	public static Int2ObjectMap<Dimension> getDimensionList() {
+		return dimensionListUnmodifiable;
 	}
 
 	public static void registerDimension(int id, Dimension dimension)
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index d15adc538..fae52fcef 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2004,6 +2004,41 @@ public class World implements WorldSource {
         return false;
     }
 
+    public boolean isMaterialInBB(AABB aabb, Material material)
+    {
+        int minX_i = MathHelper.floor(aabb.minX);
+        int maxX_i = MathHelper.floor(aabb.maxX + 1.0D);
+        int minY_i = MathHelper.floor(aabb.minY);
+        int maxY_i = MathHelper.floor(aabb.maxY + 1.0D);
+        int minZ_i = MathHelper.floor(aabb.minZ);
+        int maxZ_i = MathHelper.floor(aabb.maxZ + 1.0D);
+        for(int _x = minX_i; _x < maxX_i; _x++)
+        {
+            for(int _y = minY_i; _y < maxY_i; _y++)
+            {
+                for(int _z = minZ_i; _z < maxZ_i; _z++)
+                {
+                    Block<?> block = Blocks.blocksList[getBlockId(_x, _y, _z)];
+                    if(block != null) {
+                        boolean isMaterial = false;
+                        if (block.getMaterial() == material) {
+                            isMaterial = true;
+                            break;
+                        }
+                        if (!isMaterial) continue;
+
+                        if (aabb.intersects(block.getBlockBoundsFromState(this, _x, _y, _z).move(_x, _y, _z))){
+                            return true;
+                        }
+
+                    }
+                }
+            }
+        }
+
+        return false;
+    }
+
     public boolean isAABBInMaterial(AABB aabb, Material material)
     {
         int i = MathHelper.floor(aabb.minX);
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
index 35ba89ae4..ef6d83e51 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
@@ -1,45 +1,47 @@
 package net.minecraft.core.world.biome.provider;
 
+import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.biome.Biome;
-
-import java.util.HashMap;
-import java.util.Map;
+import org.slf4j.Logger;
 
 public abstract class BiomeProvider
 {
-    public Biome getBiome(int x, int y, int z)
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public Biome getBiome(final int x, final int y, final int z)
     {
-        Biome[] out = getBiomes(null, x, y, z, 1, 1, 1);
+        final Biome[] out = getBiomes(null, x, y, z, 1, 1, 1);
         return out[0];
     }
 
-    public double getTemperature(int x, int z)
+    public double getTemperature(final int x, final int z)
     {
-        double[] out = getTemperatures(null, x, z, 1, 1);
+        final double[] out = getTemperatures(null, x, z, 1, 1);
         return out[0];
     }
 
-    public double getHumidity(int x, int z)
+    public double getHumidity(final int x, final int z)
     {
-        double[] out = getHumidities(null, x, z, 1, 1);
+        final double[] out = getHumidities(null, x, z, 1, 1);
         return out[0];
     }
 
-    public double getVariety(int x, int z)
+    public double getVariety(final int x, final int z)
     {
-        double[] out = getVarieties(null, x, z, 1, 1);
+        final double[] out = getVarieties(null, x, z, 1, 1);
         return out[0];
     }
 
 
-    public double getBiomeness(int x, int y, int z)
+    public double getBiomeness(final int x, final int y, final int z)
     {
-        double[] out = getBiomenesses(null, x, y, z, 1, 1, 1);
+        final double[] out = getBiomenesses(null, x, y, z, 1, 1, 1);
         return out[0];
     }
 
-    public Biome[] getBiomes(Biome[] biomes, int x, int y, int z, int xSize, int ySize, int zSize)
+    public Biome[] getBiomes(final Biome[] biomes, final int x, final int y, final int z, final int xSize, final int ySize, final int zSize)
     {
         return getBiomes(biomes, null, null, null, x, y, z, xSize, ySize, zSize);
     }
@@ -58,49 +60,49 @@ public abstract class BiomeProvider
     protected void generateBiomeDistributionStats()
     {
         int lastReport = 0;
-        int sizeChunks = 2048;
+        final int sizeChunks = 2048;
         int chunksSampled = 0;
-        Map<Biome, Integer> biomeOccurrenceMap = new HashMap<>();
+        final Object2IntMap<Biome> biomeOccurrenceMap = new Object2IntArrayMap<>();
         double tempAcc = 0.0;
         double humAcc = 0.0;
 
-        System.out.println("Sampling " + sizeChunks * sizeChunks + " chunks for biome test...");
+        LOGGER.info("Sampling " + sizeChunks * sizeChunks + " chunks for biome test...");
 
         for (int x = -sizeChunks / 2; x < sizeChunks / 2; x++)
         {
             for (int z = -sizeChunks / 2; z < sizeChunks / 2; z++)
             {
-                int pctg = (int) (chunksSampled / (float)(sizeChunks * sizeChunks) * 100);
+                final int pctg = (int) (chunksSampled / (float)(sizeChunks * sizeChunks) * 100);
                 if (pctg != lastReport)
                 {
-                    System.out.println(pctg + "% complete...");
+                    LOGGER.info("{}% complete...", pctg);
                     lastReport = pctg;
                 }
                 tempAcc += getTemperature(x * 16, z * 16);
                 humAcc += getHumidity(x * 16, z * 16);
-                Biome biome = getBiome(x * 16, 64, z * 16);
+                final Biome biome = getBiome(x * 16, 64, z * 16);
                 biomeOccurrenceMap.put(biome, biomeOccurrenceMap.getOrDefault(biome, 0) + 1);
                 chunksSampled++;
             }
         }
 
-        System.out.println("Seed analysis sampling " + sizeChunks * sizeChunks + " chunks:");
-        System.out.println("    Average temperature: " + String.format("%.2f", tempAcc / (float) (sizeChunks * sizeChunks)));
-        System.out.println("    Average humidity: " + String.format("%.2f", humAcc / (float) (sizeChunks * sizeChunks)));
-        System.out.println("    Biome distribution:");
-        for (Biome biome : Registries.BIOMES)
+        LOGGER.info("Seed analysis sampling " + sizeChunks * sizeChunks + " chunks:");
+        LOGGER.info("    Average temperature: {}", String.format("%.2f", tempAcc / (float) (sizeChunks * sizeChunks)));
+        LOGGER.info("    Average humidity: {}", String.format("%.2f", humAcc / (float) (sizeChunks * sizeChunks)));
+        LOGGER.info("    Biome distribution:");
+        for (final Biome biome : Registries.BIOMES)
         {
             float pctg;
             if (biomeOccurrenceMap.containsKey(biome))
             {
-                pctg = biomeOccurrenceMap.get(biome) / (float) (sizeChunks * sizeChunks);
+                pctg = biomeOccurrenceMap.getInt(biome) / (float) (sizeChunks * sizeChunks);
                 pctg *= 100;
             }
             else
             {
                 pctg = 0.0f;
             }
-            System.out.println("        " + Registries.BIOMES.getKey(biome) + ": " + String.format("%.2f", pctg) + "%");
+            LOGGER.info("        {}: {}%", Registries.BIOMES.getKey(biome), String.format("%.2f", pctg));
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index e78616393..0450575ff 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.entity.TileEntity;
@@ -252,7 +253,7 @@ public class ChunkLoaderLegacy
         chunk.humidity = reader.getHumidityMap();
 
         // Read registries
-        Map<Integer, String> biomeRegistry = reader.getBiomeRegistry();
+        Int2ObjectMap<String> biomeRegistry = reader.getBiomeRegistry();
 
         // Read sections
         for (int i = 0; i < ChunkSection.SECTION_SIZE_Y; i++) {
@@ -315,7 +316,7 @@ public class ChunkLoaderLegacy
         return chunk;
     }
 
-    public static void loadChunkSectionFromCompound(ChunkSection section, ChunkReader reader, Map<Integer, String> biomeRegistry) {
+    public static void loadChunkSectionFromCompound(ChunkSection section, ChunkReader reader, Int2ObjectMap<String> biomeRegistry) {
         section.blocks = reader.getBlocks(section.yPosition);
         section.data = reader.getData(section.yPosition);
         section.skylightMap = reader.getSkyLight(section.yPosition);
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java
index d6c98202a..17fb38176 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
@@ -28,6 +29,6 @@ public abstract class ChunkReader
     public abstract boolean getIsTerrainPopulated();
     public abstract double[] getTemperatureMap();
     public abstract double[] getHumidityMap();
-    public abstract byte[] getBiomeMap(int ySection, Map<Integer, String> biomeRegistry);
-    public abstract Map<Integer, String> getBiomeRegistry();
+    public abstract byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry);
+    public abstract Int2ObjectMap<String> getBiomeRegistry();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
index f5a5f6751..092a9b4fe 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
@@ -182,14 +183,14 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public byte[] getBiomeMap(int ySection, Map<Integer, String> biomeRegistry)
+    public byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry)
     {
         // Not supported
         return null;
     }
 
     @Override
-    public Map<Integer, String> getBiomeRegistry() {
+    public Int2ObjectMap<String> getBiomeRegistry() {
         // Not supported
         return null;
     }
